//: c11:Logon.java
// Zastosowanie sowa kluczowego transient.
import java.io.*;
import java.util.*;

public class Logon implements Serializable {
  private Date date = new Date();
  private String username;
  private transient String password;
  Logon(String name, String pwd) {
    username = name;
    password = pwd;
  }
  public String toString() {
    String pwd =
      (password == null) ? "(brak)" : password;
    return "informacja: \n   " +
      "uytkownik: " + username +
      "\n   data: " + date +
      "\n   haso: " + pwd;
  }
  public static void main(String[] args)
  throws IOException, ClassNotFoundException {
    Logon a = new Logon("Kolos", "mojMalyKonik");
    System.out.println( "logowanie = " + a);
      ObjectOutputStream o =
        new ObjectOutputStream(
          new FileOutputStream("Logon.out"));
    o.writeObject(a);
    o.close();
    // Opnienie:
    int seconds = 5;
    long t = System.currentTimeMillis()
           + seconds * 1000;
    while(System.currentTimeMillis() < t)
      ;
    // A teraz odzyskujemy je:
    ObjectInputStream in =
      new ObjectInputStream(
        new FileInputStream("Logon.out"));
    System.out.println(
      "Odtwarzanie obiektu, czas " + new Date());
    a = (Logon)in.readObject();
    System.out.println( "logowanie = " + a);
  }
} ///:~
