//: c15:corba:RemoteTimeServer.java
import remotetime.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;

// Implementacja obiektu serwera
class ExactTimeServer extends _ExactTimeImplBase {
  public String getTime(){
    return DateFormat.
      getTimeInstance(DateFormat.FULL).
        format(new Date(
          System.currentTimeMillis()));
  }
}
// Implementacja aplikacji odlegej
public class RemoteTimeServer {
  // Wyrzuca wyjtki na konsol:
  public static void main(String[] args) 
  throws Exception {
    // Stworzenie i inicjacja ORB:
    ORB orb = ORB.init(args, null);
    // Stworzenie i zarejestrowanie obiektu serwera:
    ExactTimeServer timeServerObjRef = 
      new ExactTimeServer();
    orb.connect(timeServerObjRef);
    // Pobranie gwnego kontekstu nazw:
    org.omg.CORBA.Object objRef = 
      orb.resolve_initial_references(
        "NameService");
    NamingContext ncRef = 
      NamingContextHelper.narrow(objRef);
    // Przypisanie nazwy tekstowej do 
    // referencji do obiektu (wizanie):
    NameComponent nc = 
      new NameComponent("ExactTime", "");
    NameComponent[] path = { nc };
    ncRef.rebind(path, timeServerObjRef);
    // Oczekiwanie na dania klientw:
    java.lang.Object sync =
      new java.lang.Object();
    synchronized(sync){
      sync.wait();
    }
  }
} ///:~
