//: com:bruceeckel:util:CountryCapitals.java
package com.bruceeckel.util;
public class CountryCapitals {
  public static final String[][] pairs = {
    // Afryka
    {"ALGIERIA","Algier"}, {"ANGOLA","Luanda"},
    {"BENIN","Porto-Novo"}, {"BOTSWANA","Gaberone"},
    {"BURKINA FASO","Ouagadougou"}, {"BURUNDI","Bujumbura"},
    {"KAMERUN","Yaounde"}, {"WYSPY ZIELONEGO PRZYLDKA","Praia"},
    {"REPUBLIKA AFRYKI RODKOWEJ","Bangui"},
    {"CZAD","N'djamena"},  {"KOMORY","Moroni"},
    {"KONGO","Brazzaville"}, {"JIBUTI","Dijibouti"},
    {"EGIPT","Kair"}, {"GWINEA RWNIKOWA","Malabo"},
    {"ERYTREA","Asmara"}, {"ETIOPIA","Addis Ababa"},
    {"GABON","Libreville"}, {"GAMBIA","Banjul"},
    {"GHANA","Accra"}, {"GWINEA","Conakry"},
    {"GWINEA","-"}, {"BISSAU","Bissau"},
    {"WYBRZEE KOCI SONIOWEJ","Yamoussoukro"},
    {"KENIA","Nairobi"}, {"LESOTO","Maseru"},
    {"LIBERIA","Monrovia"}, {"LIBIA","Trypolis"},
    {"MADAGASKAR","Antananarivo"}, {"MALAWI","Lilongwe"},
    {"MALI","Bamako"}, {"MAURETANIA","Nouakchott"},
    {"MAURITIUS","Port Louis"}, {"MOROKO","Rabat"},
    {"MOZAMBIK","Maputo"}, {"NAMIBIA","Windhoek"},
    {"NIGER","Niamey"}, {"NIGERIA","Abuja"},
    {"RWANDA","Kigali"}, {"SAO TOME I PRINCIPE","Sao Tome"},
    {"SENEGAL","Dakar"}, {"SESZELE","Victoria"},
    {"SIERRA LEONE","Freetown"}, {"SOMALIA","Mogadisz"},
    {"REPUBLIKA POUDNIOWEJ AFRYKI","Pretoria/Cape Town"}, {"SUDAN","Khartoum"},
    {"SWAZILAND","Mbabane"}, {"TANZANIA","Dodoma"},
    {"TOGO","Lome"}, {"TUNEZJA","Tunis"},
    {"UGANDA","Kampala"},
    {"KONGO","Kinshasa"},
    {"ZAMBIA","Lusaka"}, {"ZIMBABWE","Harare"},
    // Azja
    {"AFGANISTAN","Kabul"}, {"BAHRAIN","Manama"},
    {"BANGLADESZ","Dhaka"}, {"BHUTAN","Thimphu"},
    {"BRUNEI","Bandar Seri Begawan"}, {"KAMBODA","Phnom Penh"},
    {"CHINY","Pekin"}, {"CYPR","Nicosia"},
    {"INDIE","New Delhi"}, {"INDONEZJA","Jakarta"},
    {"IRAN","Tehran"}, {"IRAK","Baghdad"},
    {"IZRAEL","Jerusalem"}, {"JAPONIA","Tokjo"},
    {"JORDANIA","Amman"}, {"KUWEIT","Kuwait City"},
    {"LAOS","Vientiane"}, {"LIBAN","Beirut"},
    {"MALEZJA","Kuala Lumpur"}, {"MALEDIWY","Male"},
    {"MONGOLIA","Ulan Bator"}, {"MYANMAR (BIRMA)","Rangoon"},
    {"NEPAL","Katmandu"}, {"KOREA PӣNOCNA","Fenian"},
    {"OMAN","Muscat"}, {"PAKISTAN","Islamabad"},
    {"FILIPINY","Manila"}, {"KATAR","Doha"},
    {"ARABIA SAUDYJSKA","Riyadh"}, {"SINGAPUR","Singapur"},
    {"KOREA POUDNIOWA","Seul"}, {"SRI LANKA","Colombo"},
    {"SYRIA","Damaszek"}, {"TAIWAN (REPUBLIKA CHISKA)","Taipei"},
    {"TAJLANDIA","Bangkok"}, {"TURCJA","Ankara"},
    {"ZJEDNOCZONE EMIRATY ARABSKIE","Abu Dhabi"}, {"WIETNAM","Hanoi"},
    {"JEMEN","Sana'a"},
    // Australia i Oceania
    {"AUSTRALIA","Canberra"}, {"FIJI","Suva"},
    {"KIRIBATI","Bairiki"},
    {"WYSPY MARSHALA","Dalap-Uliga-Darrit"},
    {"MICRONEZJA","Palikir"}, {"NAURU","Yaren"},
    {"NOWA ZELANDIA","Wellington"}, {"PALAU","Koror"},
    {"PAPUA NOWA GWINEA","Port Moresby"},
    {"WYSPY SOLOMONA","Honaira"}, {"TONGA","Nuku'alofa"},
    {"TUVALU","Fongafale"}, {"VANUATU","Port-Vila"},
    {"SAMOA ZACHODNIA","Apia"},
    // Europa Wschodnia i dawny ZSRR 
    {"ARMENIA","Yerevan"}, {"AZERBEJDAN","Baku"},
    {"BIAORU","Misk"}, {"GRUZJA","Tbilisi"},
    {"KAZACHSTAN","Almaty"}, {"KIRGIZSTAN","Alma-Ata"},
    {"MOLDAWIA","Chisinau"}, {"ROSJA","Moskwa"},
    {"TADYKISTAN","Dushanbe"}, {"TURKMENISTAN","Ashkabad"},
    {"UKRAINA","Kijw"}, {"UZBEKISTAN","Taszkent"},
    // Europa 
    {"ALBANIA","Tirana"}, {"ANDORA","Andorra la Vella"},
    {"AUSTRIA","Wiede"}, {"BELGIA","Bruksela"},
    {"BONIA","-"}, {"HERCEGOWINA","Sarajewo"},
    {"CHORWACJA","Zagrzeb"}, {"REPUBLIKA CZESKA","Praga"},
    {"DENIA","Kopenhaga"}, {"ESTONIA","Tallinn"},
    {"FINLANDIA","Helsinki"}, {"FRANCJA","Pary"},
    {"NIEMCY","Berlin"}, {"GRECJA","Ateny"},
    {"WGRY","Budapest"}, {"ISLANDIA","Reykjavik"},
    {"IRLANDIA","Dublin"}, {"WOCHY","Rzym"},
    {"OTWA","Ryga"}, {"LIECHTENSTEIN","Vaduz"},
    {"LITWA","Wilno"}, {"LUXEMBOURG","Luxembourg"},
    {"MACEDONIA","Skopje"}, {"MALTA","Valletta"},
    {"MONAKO","Monako"}, {"MONTENEGRO","Podgorica"},
    {"HOLANDIA","Amsterdam"}, {"NORWEGIA","Oslo"},
    {"POLSKA","Warszawa"}, {"PORTUGALIA","Lisbona"},
    {"RUMUNIA","Bukareszt"}, {"SAN MARINO","San Marino"},
    {"SERBIA","Belgrad"}, {"SOWACJA","Bratysawa"},
    {"SOWENIA","Ljubljana"}, {"HISZPANIA","Madryt"},
    {"SZWECJA","Stockholm"}, {"SZWAJCARIA","Berno"},
    {"ANGLIA","Londyn"}, {"WATYKAN","---"},
    // Pnocna i Centralna Ameryka
    {"ANTIGUA I BARBUDA","Saint John's"}, {"BAHAMAY","Nassau"},
    {"BARBADOS","Bridgetown"}, {"BELIZE","Belize City"},
    {"KANADA","Ottawa"}, {"COSTA RICA","San Jose"},
    {"KUBA","Hawana"}, {"DOMINIKA","Roseau"},
    {"REPUBLIKA DOMINIKANY","Santo Domingo"},
    {"SALWADOR","San Salvador"}, {"GRENADA","Saint George's"},
    {"GUATEMALA","Guatemala City"}, {"HAITI","Port-au-Prince"},
    {"HONDURAS","Tegucigalpa"}, {"JAMAJKA","Kingston"},
    {"MEKSYK","Mexico City"}, {"NIKARAGUA","Managua"},
    {"PANAMA","Panama City"}, {"ST. KITTS","-"},
    {"NEVIS","Basseterre"}, {"ST. LUCIA","Castries"},
    {"ST. VINCENT I GRENADYNY","Kingstown"},
    {"STANY ZJEDNOCZONE AMERYKI","Waszyngton, D.C."},
    // Ameryka Poudniowa
    {"ARGENTYNA","Buenos Aires"},
    {"BOLIWIA","Sucre (oficjalnie)/La Paz(administracyjnie)"},
    {"BRAZYLIA","Brazylia"}, {"CHILE","Santiago"},
    {"COLUMBIA","Bogota"}, {"EKWADOR","Quito"},
    {"GUJANA","Georgetown"}, {"PARAGWAJ","Asuncion"},
    {"PERU","Lima"}, {"SURINAME","Paramaribo"},
    {"TRYNIDAD I TOBAGO","Port of Spain"},
    {"URUGWAJ","Montevideo"}, {"WENEZUELA","Karakas"},
  };
} ///:~
